// (c) by Sitsanlis Ilias All rights reserved

var t=0;
var dt=1/120;

var isInSlowMotion=false
var dtInitial = dt;
var dtSlow = dt;

var toRad=Math.PI/180;
var toDeg=180/Math.PI;

var factor = 1/2;
var playMovie=false;
var framePlay=false;

var ic=10;
var rc=10;
var dx=720//window.innerWidth;
var dy=400//window.innerHeight;

var container;
var camera, scene, renderer;
var controls;
var BVec, plane //,BVecY2
var angle;
var B=1.6;
var dLB=6*5/B;
var nB=Math.round(25/dLB);
var toRad=Math.PI/180
var fieldShowFlag=true
var θ=0
var A=1
var ω=-2*Math.PI*50

    
 var myControls = new function() {
    this['Γωνία περιστροφής'] = 0;
    this['Ένταση Μαγνητικού πεδίου (mT)'] = B;
  	//this['Εμβαδό Επιφάνειας (m2)'] = A;
    this['Εμφάνιση Δυναμικών Γραμμών'] = fieldShowFlag;
}
var gui

// ΑΡΧΙΚΟΠΟΙΗΣΗ
function initilaze() {
	init();
	animate();
	//restart();
}
// ΕΠΑΝΕΚΚΙΝΗΣΗ
function restart() {
	t=0;
	θ=0
	//updateControlsGui()
}

function init() {
	container = document.getElementById("myCamvas");

	// ΠΡΟΣΘΗΚΗ ΣΚΗΝΗΣ
	scene = new THREE.Scene();
	//scene.rotation.set(0,0,Math.PI/2)

	// Η camera
	camera = new THREE.PerspectiveCamera( 40, dx/dy, 1, 2000 );
	camera.position.set( 1.2*45, 1.2*25, 1.2*100 );
	//camera.rotation.set(Math.PI/2,0,0)
	//scene.add( camera );
	//camera.position.y = 100;
	//camera.position.z = 90;
	//camera.position.y = -90;
	//camera.position.x = 100;

	

	
	var customContainer = document.getElementById('gui');
	gui = new dat.GUI( { autoPlace: false } )
	customContainer.appendChild(gui.domElement);
	var rotX = gui.add(myControls, 'Γωνία περιστροφής').min(-180).max(180).step(1);
	var rotZ = gui.add(myControls, 'Ένταση Μαγνητικού πεδίου (mT)').min(0).max(5);
	//var rotA = gui.add(myControls, 'Εμβαδό Επιφάνειας (m2)').min(1).max(4).step(.1);;
	var fieldShow = gui.add(myControls, 'Εμφάνιση Δυναμικών Γραμμών');
	
	gui.close();
	gui.width=722;

	rotX.onFinishChange(function(value) {
  		myControls['Γωνία περιστροφής'] = 15*Math.round(value/15)
		/*for (var i in gui.__controllers) {
    		gui.__controllers[i].updateDisplay();
  		}*/
		gui.__controllers[1].updateDisplay();
		θ=15*Math.round(-value/15)
  		updateAngle(θ*toRad);
		//document.getElementById('bottomTxt').innerHTML="Φ="+(B*A*Math.cos(θ*toRad)).toFixed(1)+" mWb";
	});
	rotZ.onFinishChange(function(value) {
		B=value;
  		drawMagneticField();
	});
	

	fieldShow.onFinishChange(function(value) {
		fieldShowFlag=value;
  		drawMagneticField();
	});
	

	rotX.onChange(function(value) {
		θ=-value
  		updateAngle(-θ*toRad);
		//document.getElementById('bottomTxt').innerHTML="Φ="+(B*A*Math.cos(θ*toRad)).toFixed(1)+" mWb"
	});
	rotZ.onChange(function(value) {
		B=value;
		//document.getElementById('bottomTxt').innerHTML="Φ="+(B*A*Math.cos(θ*toRad)).toFixed(1)+" mWb"
  		drawMagneticField();
	});
	/*rotA.onChange(function(value) {
		A=value;
		var x=Math.sqrt(A)
		plane.scale.x=x
		plane.scale.z=x
		if (nB!=Math.round(Math.sqrt(A)*25/dLB) && fieldShowFlag) {
			drawMagneticField();
		}
		
		//document.getElementById('bottomTxt').innerHTML="Φ="+(B*A*Math.cos(θ*toRad)).toFixed(1)+" mWb"
	});
	rotA.onFinishChange(function(value) {
  		//drawMagneticField();
		//document.getElementById('bottomTxt').innerHTML="Φ="+(B*A*Math.cos(θ*toRad)).toFixed(1)+" mWb"
	});*/


	// ΦΩΤΙΣΜΟΣ
	scene.add( new THREE.AmbientLight( 0xffffff ) );

	// ΔΗΜΙΟΥΡΓΙΑ ΕΠΙΠΕΔΟΥ
	/*var planeMaterial = new THREE.MeshLambertMaterial({
		color: 0xaa0000,
		map: THREE.ImageUtils.loadTexture("fora.png"),
		side:THREE.DoubleSide,
		transparent: true
		//opacity:0.5
	})*/


	var material = new THREE.MeshBasicMaterial({color: 0xcccccc, side: THREE.DoubleSide,transparent:true,opacity:.8});
	var geomety = new THREE.PlaneGeometry( 40, 65, 1, 1 );
	geomety.applyMatrix( new THREE.Matrix4().makeRotationX( Math.PI/2  ) );
	plane = new THREE.Mesh(geomety, material);
	
	// 2 ΜΕΓΑΛΟΙ ΑΓΩΓΟΙ
	var width=0.6
	var cylinderGeometry = new THREE.CubeGeometry( width, width, 65 );
	cylinderGeometry.applyMatrix( new THREE.Matrix4().makeRotationZ( Math.PI/2  ) );
	cylinder1 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x666666, transparent:false } ) );
	cylinder1.position.set( 20, 0, 0 );
	cylinder2 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x666666, transparent:false } ) );
	cylinder2.position.set( -20, 0, 0 );
	
	// 2 ΑΝΙΣΑ ΤΜΗΜΑΤΑ
	var cylinderGeometry = new THREE.CubeGeometry( width, width, 20);
	cylinderGeometry.applyMatrix( new THREE.Matrix4().makeRotationZ( Math.PI/2  ) );
	cylinder6 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x666666, transparent:false } ) );
	cylinder6.position.set( -1.5, 0, 42.2 );
	var cylinderGeometry = new THREE.CubeGeometry( width, width, 20);
	cylinderGeometry.applyMatrix( new THREE.Matrix4().makeRotationZ( Math.PI/2  ) );
	cylinder7 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x666666, transparent:false } ) );
	cylinder7.position.set( 1.5, 0, 42.2 );
	
	
	
	var cylinderGeometry = new THREE.CubeGeometry( width, width, 40.6);
	cylinderGeometry.applyMatrix( new THREE.Matrix4().makeRotationY( Math.PI/2  ) );
	cylinder3 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x666666, transparent:false } ) );
	cylinder3.position.set( 0, 0, -32.5 );
	
	// ΑΚΡΟΛΕΙΠΤΕΣ
	var cylinderGeometry = new THREE.CubeGeometry( width, width, 2);
	cylinderGeometry.applyMatrix( new THREE.Matrix4().makeRotationY( Math.PI/2  ) );
	cylinder8 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x666666, transparent:false } ) );
	cylinder8.position.set( -2.6, 0, 51.9 );
	cylinder9 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x666666, transparent:false } ) );
	cylinder9.position.set( 2.6, 0, 51.9 );
	
	// Torus
	var geometry = new THREE.Geometry();
	var geometry = new THREE.TorusGeometry( 4.1,.5, 20, 50,-2.8 );
	geometry.applyMatrix( new THREE.Matrix4().makeRotationZ(-0.17-Math.PI/2 ));
	geometry.applyMatrix( new THREE.Matrix4().translate( new THREE.Vector3(0,0, 51.9) ) );
	geometry.computeVertexNormals();
	torus1 = new THREE.Mesh(geometry, new THREE.MeshBasicMaterial( {
		color: 0x000099,
		//shading: THREE.SmoothShading,
		//transparent:true,
		//opacity:0.5,
		overdraw:true
	}));
	
	var geometryT = new THREE.Geometry();
	var geometryT = new THREE.TorusGeometry( 4.1,.5, 20, 50,2.8);
	geometryT.applyMatrix( new THREE.Matrix4().makeRotationZ(0.17-Math.PI/2 ));
	geometryT.applyMatrix( new THREE.Matrix4().translate( new THREE.Vector3(0,0, 51.9) ) );
	geometry.computeVertexNormals();
	torus2 = new THREE.Mesh(geometryT, new THREE.MeshBasicMaterial( {
		color: 0x990000,
		//shading: THREE.SmoothShading,
		overdraw:true
	}));
	
	
	scene.add(torus1)
	scene.add(torus2)
	
	var cylinderGeometry = new THREE.CubeGeometry( width, width, 18.6);
	cylinderGeometry.applyMatrix( new THREE.Matrix4().makeRotationY( Math.PI/2  ) );
	cylinder4 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x666666, transparent:false } ) );
	cylinder4.position.set( 11, 0, 32.5 );
	
	cylinder5 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x666666, transparent:false } ) );
	cylinder5.position.set( -11, 0, 32.5 );
	
	
	var cylinderGeometry = new THREE.CubeGeometry( width, width, 5);
	cylinderGeometry.applyMatrix( new THREE.Matrix4().makeRotationY( Math.PI/2  ) );
	cylinder10 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x990000, transparent:false } ) );
	cylinder10.position.set( 6.5, 0, 51.9 );
	
	cylinder11 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x000099, transparent:false } ) );
	cylinder11.position.set( -6.5, 0, 51.9 );
	
	
	// ΜΠΑΤΑΡΙΑ
	/*var map = THREE.ImageUtils.loadTexture( 'battery1.png' );
				map.wrapS = map.wrapT = THREE.RepeatWrapping;
				map.anisotropy = 16;
				
	materials = [
				new THREE.MeshLambertMaterial( { ambient: 0xffffff, map: map, side: THREE.DoubleSide } ),
				new THREE.MeshLambertMaterial( { color: 0x009900, wireframe: false, transparent: true, opacity: 0, side: THREE.DoubleSide } )
			];*/
			
	var batteryGeometry = new THREE.CylinderGeometry( 2, 2, 8, 20, 1 );
	batteryGeometry.applyMatrix( new THREE.Matrix4().makeRotationZ( Math.PI/2  ) );
	battery = new THREE.Mesh( batteryGeometry, new THREE.MeshBasicMaterial( { color: 0x000000, transparent:false } ) );
	//battery = THREE.SceneUtils.createMultiMaterialObject( batteryGeometry, materials );
	battery.position.set( -2, -10, 51.9 );
	scene.add( battery );
	
	
	var batteryPosCapGeometry = new THREE.CylinderGeometry( 1, 1, 1, 20, 1 );
	batteryPosCapGeometry.applyMatrix( new THREE.Matrix4().makeRotationZ( Math.PI/2  ) );
	batteryCap = new THREE.Mesh( batteryPosCapGeometry, new THREE.MeshBasicMaterial( { color: 0x666666, transparent:false } ) );
	batteryCap.position.set( 5.2, -10, 51.9 );
	scene.add( batteryCap );
	
	
	var batteryPosCap0Geometry = new THREE.CylinderGeometry( 2, 2, 3, 20, 1 );
	batteryPosCap0Geometry.applyMatrix( new THREE.Matrix4().makeRotationZ( Math.PI/2  ) );
	batteryCap0 = new THREE.Mesh( batteryPosCap0Geometry, new THREE.MeshBasicMaterial( { color: 0xECA548, transparent:false } ) );
	batteryCap0.position.set( 3.5, -10, 51.9 );
	scene.add( batteryCap0 );
	
	// ΑΡΝΗΤΙΚΟΣ ΠΟΛΟΣ
	var batteryNegCap0Geometry = new THREE.CylinderGeometry( 1, 1, 3, 20, 1 );
	batteryNegCap0Geometry.applyMatrix( new THREE.Matrix4().makeRotationZ( Math.PI/2  ) );
	batteryCap1 = new THREE.Mesh( batteryNegCap0Geometry, new THREE.MeshBasicMaterial( { color: 0x666666, transparent:false } ) );
	batteryCap1.position.set( -4.54, -10, 51.9 );
	scene.add( batteryCap1 );
	
	
	//ΣΥΝΔΕΣΕΙΣ ΜΕ ΤΗΝ ΜΠΑΤΑΡΙΑ
	// ΚΑΤΑΚΟΡΥΦΑ ΤΜΗΜΑΤΑ
	var cylinderGeometry = new THREE.CubeGeometry( width, width, 10);
	cylinderGeometry.applyMatrix( new THREE.Matrix4().makeRotationX( Math.PI/2  ) );
	cylinder12 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x990000, transparent:false } ) );
	cylinder12.position.set( 9.3, -4.7, 51.9 );
	scene.add( cylinder12 );
	cylinder13 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x000099, transparent:false } ) );
	cylinder13.position.set( -9.3, -4.7, 51.9 );
	scene.add( cylinder13 );
	
	var cylinderGeometry = new THREE.CubeGeometry( width, width, 5);
	cylinderGeometry.applyMatrix( new THREE.Matrix4().makeRotationY( Math.PI/2  ) );
	cylinder14 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x990000, transparent:false } ) );
	cylinder14.position.set( 7.1, -10, 51.9 );
	
	cylinder15 = new THREE.Mesh( cylinderGeometry, new THREE.MeshBasicMaterial( { color: 0x000099, transparent:false } ) );
	cylinder15.position.set( -7.1, -10, 51.9 );
	
	scene.add( cylinder14 );
	scene.add( cylinder15 );
	


	var geometry = new THREE.PlaneGeometry(1.2, 1.2);
	//geometry1.applyMatrix( new THREE.Matrix4().makeRotationZ( 2*Math.PI/3 ) );
	var material = new THREE.MeshLambertMaterial({
		map: THREE.ImageUtils.loadTexture("images/pos.png"),
		side:THREE.DoubleSide,
		transparent: true
		})
	posText = new THREE.Mesh(geometry, material);
	posText.position.set( 3.5, -10, 54 );
	scene.add(posText)
	//var geomety2 = new THREE.PlaneGeometry( 40, 40, 1, 1 );
	//geomety2.applyMatrix( new THREE.Matrix4().makeRotationX( -Math.PI/2  ) );
	//plane2 = new THREE.Mesh(geomety2, planeMaterial);
	//plane.add(plane2)
	//plane2.position.set(0,0.6,0)
	
	//plane.overdraw = true;
	scene.add(plane);
	Obj = new THREE.Object3D();
	Obj.add( cylinder1 );
	Obj.add( cylinder2 );
	Obj.add( cylinder3 );
	Obj.add( cylinder4 );
	Obj.add( cylinder5 );
	Obj.add( cylinder6 );
	Obj.add( cylinder7 );
	Obj.add( cylinder8 );
	Obj.add( cylinder9 );
	scene.add( cylinder10 );
	scene.add( cylinder11 );

	// ΚΑΘΕΤΟ ΔΙΑΝΥΣΜΑ
	//BVecY2 = new THREE.myVector( new THREE.Vector3( 0, 1, 0 ), new THREE.Vector3( 0, 0.01, 0 ), 15 , 0.5);
	//BVecY2.setColor(0x0000ff);
	//Obj.add(BVecY2);
	
	// FL1
	FL1Vec = new THREE.myVector( new THREE.Vector3( 0, 1, 0 ), new THREE.Vector3( -20, 0.01, 0 ), 15 , 0.5);
	FL1Vec.setColor(0x005500);
	scene.add(FL1Vec);
	FL1Text = makeTextSprite( " F", { fontsize: 20, fontface: "Georgia", borderColor: {r:0, g:0, b:255, a:1.0} } );
	FL1Vec.add( FL1Text );
	
	
	
	// FL2
	FL2Vec = new THREE.myVector( new THREE.Vector3( 0, 1, 0 ), new THREE.Vector3( 20, 0.01, 0 ), 15 , 0.5);
	FL2Vec.setColor(0x005500);
	scene.add(FL2Vec);
	FL2Text = makeTextSprite( " F", { fontsize: 20, fontface: "Georgia", borderColor: {r:0, g:0, b:255, a:1.0} } );
	FL2Vec.add( FL2Text );
	
	
	//I1
	I1Vec = new THREE.myVector( new THREE.Vector3( 0, 0, 1 ), new THREE.Vector3( -25, 0.01, 0 ), 15 , 0.3);
	I1Vec.setColor(0x000099);
	Obj.add(I1Vec);
	I1Text = makeTextSprite( " I", { fontsize: 20, fontface: "Georgia", borderColor: {r:0, g:0, b:255, a:1.0} } );
	I1Vec.add( I1Text );
	
	//I2
	I2Vec = new THREE.myVector( new THREE.Vector3( 0, 0, 1 ), new THREE.Vector3( 25, 0.01, 0 ), 15 , 0.3);
	I2Vec.setColor(0x000099);
	Obj.add(I2Vec);
	I2Text = makeTextSprite( " I", { fontsize: 20, fontface: "Georgia", borderColor: {r:0, g:0, b:255, a:1.0} } );
	I2Vec.add( I2Text );


	scene.add(Obj)

	// ΕΤΙΚΕΤΕΣ
	var material1 = new THREE.MeshLambertMaterial({
		map: THREE.ImageUtils.loadTexture("images/B.png"),
		side:THREE.DoubleSide,
		transparent: true
	})
	var geometry1 = new THREE.PlaneGeometry(4,8);
	textB = new THREE.Mesh(geometry1, material1);

	/*var material2 = new THREE.MeshLambertMaterial({
		map: THREE.ImageUtils.loadTexture("n.png"),
		side:THREE.DoubleSide,
		transparent: true
	})*/

	
		
	
	//var geometry2 = new THREE.PlaneGeometry(4, 8)
	//textn = new THREE.Mesh(geometry2, material2);
	
	//textn.position.set(0,17,-3);
	//textn.rotation.set(0,Math.PI/3,0);

	//BVecY2.add(textn);

	updateAngle(0);
	//document.getElementById('bottomTxt').innerHTML="Φ="+(B*Math.cos(θ*toRad)).toFixed(1)+" mWb"
	drawMagneticField();

	// WebGl - Canvas Rendering
	if ( ! Detector.webgl ) {
		renderer = new THREE.CanvasRenderer();
	} else {
		renderer = new THREE.WebGLRenderer( { antialias: true } );
	}
	renderer.setSize( dx, dy );

	// Controls
	container.appendChild( renderer.domElement );
	//window.addEventListener( 'resize', onWindowResize, false );
	
	controls = new THREE.TrackballControls( camera, renderer.domElement );
	controls.target.set( 0, 0, 0 );
	controls.rotateSpeed = 0.1;
	controls.zoomSpeed = 0.2;
	controls.panSpeed = 0.2;
	controls.noZoom = false;
	controls.noPan = false;
	controls.staticMoving = false;
	controls.dynamicDampingFactor = 0.2;

	// ΓΙΑ Orbit COntrol
	//controls = new THREE.OrbitControls( camera );
	//controls.addEventListener( 'change', render );
	controls = new THREE.OrbitControls( camera , renderer.domElement );
}

/*function onWindowResize() {
	dx=window.innerWidth;
	dy=window.innerHeight;
	camera.aspect = dx/dy
	camera.updateProjectionMatrix();
	renderer.setSize( dx,dy);
	render();
}*/
// ΣΧΕΔΙΑΣΗ ΓΩΝΙΑΣ
function updateAngle(θ) {
	//BVecY2.remove(angle );
	/*if (B!=0) {
		var material = new THREE.MeshBasicMaterial({color: 0x000099, side: THREE.DoubleSide});
		var α1=θ//myControls['Γωνία περιστροφής']*Math.PI/180;
		var startAngle=Math.PI/2-α1;
		var finishAngle=α1;
		
		if (α1>Math.PI) { 
			α1=2*Math.PI-α1+Math.PI/2;
			startAngle=α1;
			finishAngle=Math.PI/2-α1;
		}
		
		angle = new THREE.Mesh(new THREE.CircleGeometry( 7, 25, startAngle,finishAngle), material);
		angle.rotation.y=Math.PI/2;
		//BVecY2.add(angle);
	}*/
}

// ΣΧΕΔΙΑΣΗ ΔΥΝΑΜΙΚΩΝ ΓΡΑΜΜΩΝ
function drawMagneticField() {
	scene.remove(BVec );
	//angle.visible=false
	if (B!=0) {
		//angle.visible=true;
		dLB=6*5/B;
		nB=Math.round(Math.sqrt(A)*25/dLB);
		nBx=Math.round(20/dLB);
		nBy=Math.round(32.5/dLB);
		
		BVec = new THREE.myVector( new THREE.Vector3( 1, 0, 0 ), new THREE.Vector3( 0, 0, 0.02 ), B*10 , 0.4);
		BVec.setColor(0x009900);
		scene.add(BVec);

		//textB.position.set(2,B*10+2,0)
		//textB.rotation.set(0,Math.PI/3,0)
		textB.rotation.set(0,0,Math.PI/2)
		textB.position.set(0,B*10+4,2)
		BVec.add(textB);


		if (fieldShowFlag) {
			for (var i=-nBx;i<=nBx;i++) {
				for (var j=-nBy;j<=nBy;j++) {
					var BVec2 = new THREE.myVector( new THREE.Vector3( 0, 1, 0 ), new THREE.Vector3( i*dLB, -40, j*dLB ), 80 , 0.2);
					BVec2.setColor(0x999999,1);
					BVec.add(BVec2);
				}
			}
		}
	}
}

// ΣΕ ΚΑΘΕ FRAME
function animate() {
	requestAnimationFrame( animate );
	
	if (playMovie) {
		if (framePlay) {
			playMovie=false;
			framePlay=false;
		}
		t+=dt;
		calculations();
	}
	
	render();
	update();	
}
function render() {
	//var timer = Date.now() * 0.0005;
	//camera.position.z = Math.cos( timer ) * 200;
	//camera.position.x = Math.sin( timer ) * 200;
	camera.lookAt( scene.position );
	renderer.render( scene, camera );

	//console.log(camera.rotation.x+","+camera.rotation.y+","+camera.rotation.z)
}
function update() {
	controls.update();
	//if (θ!=myControls['Γωνία περιστροφής']) {
		//θ=myControls['Γωνία περιστροφής']
		updateAngle(θ*toRad);
		document.getElementById('bottomTxt').innerHTML="θ="+(-θ).toFixed(1)+" <sup>o</sup>"
	//}
	var sinθ=Math.sin(θ*toRad)
	if (sinθ>0.1) {
		var ic=-5
	} else if (sinθ<-0.1) {
		var ic=5
	} else {
		var ic=0
	}
	
	FL1Vec.setLength(-B*ic)
	FL2Vec.setLength(+B*ic)
	
	
	FL1Vec.position.set(-20*Math.sin(θ*toRad),20*Math.cos(θ*toRad),0);
	FL2Vec.position.set(20*Math.sin(θ*toRad),-20*Math.cos(θ*toRad),0);
	
	var ε=B*ic<0?-1:1
	FL1Text.position.set( 0, -B*ic-ε, 0 );
	FL2Text.position.set( 0, B*ic+ε, 0 );
	
	I1Vec.setLength(-2*ic)
	I1Text.position.set( 0, -2*ic-1, 0 );
	
	I2Vec.setLength(+2*ic)
	I2Text.position.set( 0, +2*ic+1, 0 );
	
	FL1Text.visible=B*ic!=0
	FL2Text.visible=B*ic!=0
	
	I1Text.visible=ic!=0
	I2Text.visible=ic!=0
	
	plane.rotation.z = (θ-90)*Math.PI/180;
	Obj.rotation.z = (θ-90)*Math.PI/180;
}
function calculations() {
	θ+=ω*dt
}

function makeTextSprite( message, parameters )
{
	if ( parameters === undefined ) parameters = {};
	
	var fontface = parameters.hasOwnProperty("fontface") ? 
		parameters["fontface"] : "Arial";
	
	var fontsize = parameters.hasOwnProperty("fontsize") ? 
		parameters["fontsize"] : 20;
	
	var borderThickness = parameters.hasOwnProperty("borderThickness") ? 
		parameters["borderThickness"] : 2;
	
	var borderColor = parameters.hasOwnProperty("borderColor") ?
		parameters["borderColor"] : { r:0, g:0, b:0, a:1.0 };
	
	var backgroundColor = parameters.hasOwnProperty("backgroundColor") ?
		parameters["backgroundColor"] : { r:255, g:255, b:255, a:1.0 };

	var spriteAlignment = THREE.SpriteAlignment.topLeft;
		
	var canvas = document.createElement('canvas');
	var context = canvas.getContext('2d');
	context.font = fontsize + "px " + fontface;
    
	var metrics = context.measureText( message );
	var textWidth = metrics.width;

	// text color
	context.fillStyle = "rgba(0, 0, 0, 1.0)";
	context.fillText( message, borderThickness + borderThickness, fontsize);
	
	// canvas contents will be used for a texture
	var texture = new THREE.Texture(canvas) 
	texture.needsUpdate = true;
	//texture.offset=new THREE.Vector2(0,-500)

	var spriteMaterial = new THREE.SpriteMaterial( { map: texture, useScreenCoordinates: false, alignment: spriteAlignment } );
	var sprite = new THREE.Sprite( spriteMaterial );
	var spriteScale=1.2
	sprite.scale.set(50*spriteScale,25*spriteScale,0);
	
	return sprite;	
}